## ros-indigo-rc-genicam-api 2.1.0

=== CMakeLists.txt ===
# This file is part of the rc_genicam_api package.
#
# Copyright (c) 2017 Roboception GmbH
# All rights reserved
#
# Author: Heiko Hirschmueller
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its contributors
# may be used to endorse or promote products derived from this software without
# specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required (VERSION 2.8.12)

project(rc_genicam_api)
include(cmake/project_version.cmake)

enable_testing()

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/genicam/library/CPP/include)

# - Configuration for code optimization -

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RELEASE CACHE STRING "Build type: DEBUG or RELEASE" FORCE)
endif ()

# - Standard definitions -

add_definitions(-Wall)
if (CMAKE_MAJOR_VERSION VERSION_LESS "3.1.0")
  add_definitions(-std=c++11)
else ()
  set(CMAKE_CXX_STANDARD 11)
endif ()

if (CMAKE_COMPILER_IS_GNUCC)
  add_definitions(-Wno-unknown-pragmas)
endif ()

# In case of Visual Studio, enable exporting all symbols and disable some
# warnings

if (WIN32)
  add_definitions(/DGENICAM_NO_AUTO_IMPLIB)
  set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
endif ()

if (MSVC)
  add_definitions("/wd4003")
  add_definitions("/wd4514")
  add_definitions("/wd4710")
  add_definitions("/wd4820")
  add_definitions("/wd4435")
  add_definitions("/wd4668")
  add_definitions("/wd4127")
  add_definitions("/wd4265")
  add_definitions("/wd4996")
  add_definitions("/wd4437")
  add_definitions("/wd4571")
  add_definitions("/wd4355")
  add_definitions("/wd4061")
  add_definitions("/wd4800")
  add_definitions("/wd4711")
  add_definitions("/wd4774")
  add_definitions("/wd4625")
  add_definitions("/wd4626")
  add_definitions("/wd5026")
  add_definitions("/wd5027")
  add_definitions("/wd5039")
endif ()

# - Options -

option(BUILD_TOOLS "Build commandline tools" ON)
option(BUILD_DOC "Add target for building doxygen docs" ON)
option(BUILD_SHARED_LIBS "Build shared libs" ON)
option(INSTALL_COMPLETION "Install bash completion" OFF)

# - Build individual parts -

add_subdirectory(baumer)
add_subdirectory(genicam)

link_directories(${GENICAM_LIBRARIES_DIR})

add_subdirectory(rc_genicam_api)
if (BUILD_TOOLS)
  add_subdirectory(tools)
endif()
if (INSTALL_COMPLETION)
  add_subdirectory(completion)
endif ()

# export project targets

# Declare (shared) libraries that are created by your project. For all
# libraries that appear here, the following line should exist in a cmake
# file in a sub directory:
# install(TARGETS rcXXX EXPORT PROJECTTargets COMPONENT bin DESTINATION lib)
if (BUILD_SHARED_LIBS)
  set(PROJECT_LIBRARIES rc_genicam_api)
endif ()

# Declare static libraries that are created by your project. For all
# libraries that appear here, the following line should exist in a cmake
# file in a sub directory:
# install(TARGETS rcXXX_static EXPORT PROJECTTargets COMPONENT dev DESTINATION lib)
#set(PROJECT_STATIC_LIBRARIES rc_genicam_api_static)

include(cmake/configure_link_libs.cmake)

# add a target to generate API documentation with Doxygen
if (BUILD_DOC)
  add_subdirectory(doc)
endif()

# Install catkin package.xml
install(FILES package.xml COMPONENT dev DESTINATION share/${PROJECT_NAME_LOWER})
install(FILES net_perf_check.sh COMPONENT dev DESTINATION share/${PROJECT_NAME_LOWER}
        PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
                    GROUP_EXECUTE GROUP_READ
                    WORLD_EXECUTE WORLD_READ)

# - Define information for packaging -

# optionally set description and maintainer (if not set will use defaults from package_debian.cmake)
#set(CPACK_DEBIAN_PACKAGE_DESCRIPTION "Roboception package description")

# optionally set package maintainer (otherwise defaults to Roboception <support@roboception.de>)
#set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Your Name <your.name@roboception.de>")

# optionally specify dependencies of the debian package here (comma separated!)
#set(CPACK_DEBIAN_PACKAGE_DEPENDS "")

include(cmake/package_debian.cmake)

=== rc_genicam_api/CMakeLists.txt ===
# This file is part of the rc_genicam_api package.
#
# Copyright (c) 2017 Roboception GmbH
# All rights reserved
#
# Author: Heiko Hirschmueller
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its contributors
# may be used to endorse or promote products derived from this software without
# specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

project(rc_genicam_api CXX)

string(TOLOWER "${PROJECT_NAME}" PROJECT_NAME_LOWER)

if (UNIX)
  add_definitions("-DGENTL_INSTALL_PATH=\"${CMAKE_INSTALL_PREFIX}/lib/${PROJECT_NAME_LOWER}\"")
elseif (WIN32)
  add_definitions("-DGENTL_INSTALL_PATH=\"${CMAKE_INSTALL_PREFIX}/bin\"")
endif ()

set(src
  exception.cc
  system.cc
  interface.cc
  device.cc
  stream.cc
  cport.cc
  buffer.cc
  config.cc
  image.cc
  imagelist.cc
  ${CMAKE_CURRENT_BINARY_DIR}/project_version.cc
)

set(hh
  exception.h
  system.h
  interface.h
  device.h
  stream.h
  buffer.h
  config.h
  image.h
  imagelist.h
  pixel_formats.h
  ${CMAKE_CURRENT_BINARY_DIR}/project_version.h
)

if (UNIX)
  set(src ${src} gentl_wrapper_linux.cc)
elseif (WIN32)
  set(src ${src} gentl_wrapper_win32.cc)
endif ()

add_library(rc_genicam_api_static STATIC ${src})
target_link_libraries(rc_genicam_api_static ${GENICAM_LIBRARIES})
if (UNIX)
  target_link_libraries(rc_genicam_api_static dl)
endif ()

#install(TARGETS rc_genicam_api_static EXPORT PROJECTTargets COMPONENT dev DESTINATION lib)

if (BUILD_SHARED_LIBS)
  add_library(rc_genicam_api SHARED ${src})
  target_link_libraries(rc_genicam_api ${GENICAM_LIBRARIES})

  if (UNIX)
    target_link_libraries(rc_genicam_api dl)
  endif ()

  set_target_properties(rc_genicam_api PROPERTIES SOVERSION ${abiversion})

  install(TARGETS rc_genicam_api EXPORT PROJECTTargets COMPONENT bin
          RUNTIME DESTINATION bin
		  LIBRARY DESTINATION lib
		  ARCHIVE DESTINATION lib)
endif ()

# only install headers if we build and install the shared lib
if (BUILD_SHARED_LIBS)
  install(FILES ${hh} COMPONENT dev DESTINATION include/rc_genicam_api)
endif ()

=== tools/CMakeLists.txt ===
# This file is part of the rc_genicam_api package.
#
# Copyright (c) 2017 Roboception GmbH
# All rights reserved
#
# Author: Heiko Hirschmueller
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its contributors
# may be used to endorse or promote products derived from this software without
# specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

project(tools CXX)

# build programs

add_executable(gc_info gc_info.cc)
target_link_libraries(gc_info rc_genicam_api_static)

add_executable(gc_config gc_config.cc)
target_link_libraries(gc_config rc_genicam_api_static)

add_executable(gc_stream gc_stream.cc)
target_link_libraries(gc_stream rc_genicam_api_static)

if (UNIX)
  target_link_libraries(gc_stream pthread)
endif ()

add_executable(gc_pointcloud gc_pointcloud.cc)
target_link_libraries(gc_pointcloud rc_genicam_api_static)

# install tools

install(TARGETS gc_info COMPONENT bin DESTINATION bin)
install(TARGETS gc_config COMPONENT bin DESTINATION bin)
install(TARGETS gc_stream COMPONENT bin DESTINATION bin)
install(TARGETS gc_pointcloud COMPONENT bin DESTINATION bin)

=== debian/changelog ===
ros-indigo-rc-genicam-api (2.1.0-0trusty) trusty; urgency=high

  * Made System, Interface, Device and Stream objects thread safe

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 24 Jan 2019 23:00:00 -0000

ros-indigo-rc-genicam-api (2.0.4-0trusty) trusty; urgency=high

  * A buffer that is labelled to contain chunk data may also contain an image
  * Implemented fallback of open device access from readonly to control to exclusive

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 23 Jan 2019 23:00:00 -0000

ros-indigo-rc-genicam-api (2.0.3-0trusty) trusty; urgency=high

  * Improved description of some device methods
  * Under Windows, do not check install path but only current directory as default location of GenTL producer

 -- Felix Ruess <felix.ruess@roboception.de>  Tue, 08 Jan 2019 23:00:00 -0000

ros-indigo-rc-genicam-api (2.0.2-0trusty) trusty; urgency=high

  * Fixed bug in rcg::getEnum() function that may lead to a seg fault
  * Minor changes in cmake build files

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 31 Dec 2018 23:00:00 -0000

ros-indigo-rc-genicam-api (2.0.1-0trusty) trusty; urgency=high

  * Added test mode to gc_stream tool (i.e. disables saving for only testing the connection)
  * Added printing of package size to gc_stream tool
  * Added statistic to gc_stream tool
  * Removed aborting gc_stream with 'Enter' from Linux version as it causes unwanted stops in some situations
  * Minor fixes in build files.

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 20 Dec 2018 23:00:00 -0000

ros-indigo-rc-genicam-api (2.0.0-0trusty) trusty; urgency=high

  NOTE: Including multipart support required minor changes of the existing API. See readme for more
  information. Attention: The provided GenTL layer does not yet support multipart!
  * Extended Buffer and Image classes as well as the examples for handling multi-part buffers as well
    (NOTE: The provided GenTL producer does not yet support multipart!)
  * gc_stream: Using component name for storing individual images and ensuring that files are not
    overwritten
  * gc_pointcloud: Using component name for identifying images and try enabling synchronization on
    device
  * Add libs of GenICam reference implementation to external cmake dependencies of shared
    genicam_api library
  * Upgrading GenICam reference implementation to v3.1
  * Add libs of GenICam reference implementation to external dependencies of shared genicam_api
    library

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 07 Oct 2018 22:00:00 -0000

ros-indigo-rc-genicam-api (1.3.15-0trusty) trusty; urgency=high

  * Added parameter --iponly to gc_config tool

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 26 Sep 2018 22:00:00 -0000

ros-indigo-rc-genicam-api (1.3.14-0trusty) trusty; urgency=high

  * Added possibility to interrupt streaming with gc_stream by pressing 'Enter' key.
  * Undefined min/max macros in gc_pointcloud.cc on Windows to avoid compile errors

 -- Felix Ruess <felix.ruess@roboception.de>  Tue, 25 Sep 2018 22:00:00 -0000

ros-indigo-rc-genicam-api (1.3.13-0trusty) trusty; urgency=high

  * Changed output of gc_config -l to emphasize using interface and serial number as unique identifier
  * Added possibility to call a GenICam command from the command line with gc_info, gc_config and gc_stream
  * Additionally printing the internal name and display name of the GenTL producer in the gc_info tool
  * Update GEV GenTL provider from Baumer
  * Revision of readme

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 22 Aug 2018 22:00:00 -0000

ros-indigo-rc-genicam-api (1.3.12-0trusty) trusty; urgency=high

  * Getting chunk data in gc_stream and storing disparity image with all parameters for reconstruction if possible
  * Error handling in gc_stream changed by first checking for incomplete buffer and then for image present

 -- Felix Ruess <felix.ruess@roboception.de>  Tue, 17 Jul 2018 22:00:00 -0000

ros-indigo-rc-genicam-api (1.3.11-0trusty) trusty; urgency=high

  * don't install bash completion by default (doesn't work on ROS buildfarm)
  * make sure installed net_perf_check.sh script is executable

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 01 Jul 2018 22:00:00 -0000

ros-indigo-rc-genicam-api (1.3.10-0trusty) trusty; urgency=high

  * Added possibility to set GenICam parameters in gc_info too
  * Only show network summary in gc_config if called without parameters or with network related parameters
  * Corrected spelling of visard in gc_pointcloud output file name

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 27 Jun 2018 22:00:00 -0000

ros-indigo-rc-genicam-api (1.3.9-0trusty) trusty; urgency=high

  * Bash completion for UNIX and ROS
  * Relaxed synchronization in gc_pointcloud for special exposure alternate mode of rc_visard
  * Added method in image list class to request the oldest timestamp
  * Added triangulation to gc_pointcloud
  * Added parameter for output file name to gc_pointcloud
  * Fixed crashing of gc_info if enumeration does not have a value

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 14 Jun 2018 22:00:00 -0000

ros-indigo-rc-genicam-api (1.3.8-0trusty) trusty; urgency=high

  * show actually searched path instead of env var in exception if no transport layer found
  * improved README

 -- Felix Ruess <felix.ruess@roboception.de>  Tue, 17 Apr 2018 22:00:00 -0000

ros-indigo-rc-genicam-api (1.3.7-0trusty) trusty; urgency=high

  * Devices can now be discovered by serial number as well

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 08 Apr 2018 22:00:00 -0000

ros-indigo-rc-genicam-api (1.3.6-0trusty) trusty; urgency=high

  * fix path to genicam arm64 libs

 -- Felix Ruess <felix.ruess@roboception.de>  Sat, 24 Feb 2018 23:00:00 -0000

ros-indigo-rc-genicam-api (1.3.5-0trusty) trusty; urgency=high

  * add libs for arm64

 -- Felix Ruess <felix.ruess@roboception.de>  Sat, 24 Feb 2018 23:00:00 -0000

ros-indigo-rc-genicam-api (1.3.4-0trusty) trusty; urgency=high



=== debian/control ===
Source: ros-indigo-rc-genicam-api
Section: misc
Priority: extra
Maintainer: Felix Ruess <felix.ruess@roboception.de>
Build-Depends: debhelper (>= 9.0.0), cmake
Homepage: 
Standards-Version: 3.9.2

Package: ros-indigo-rc-genicam-api
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-indigo-catkin
Description: GenICam/GigE Vision Convenience Layer.
 This package combines the Roboception convenience layer for images with the GenICam reference implementation and a GigE Vision transport layer. It is a self contained package that permits configuration and image streaming of GenICam / GigE Vision 2.0 compatible cameras like the Roboception rc_visard. This package also provides some tools that can be called from the command line for discovering cameras, changing their configuration and streaming images. Although the tools are meant to be useful when working in a shell or in a script, their main purpose is to serve as example on how to use the API for reading and setting parameters, streaming and synchronizing images. See LICENSE.md for licensing terms of the different parts.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-rc-genicam-api//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
